SystemOrganization addCategory: #MarianoBuilder!

Object subclass: #ConfigurationOfMariano
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'MarianoBuilder'!

!ConfigurationOfMariano class methodsFor: 'development support' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfMariano class methodsFor: 'private' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfMariano class methodsFor: 'building' stamp: 'MarianoMartinezPeck 10/21/2011 14:15'!
buildCogVMImage
	CogVMImageBuilder new buildImage.! !

!ConfigurationOfMariano class methodsFor: 'building' stamp: 'MarianoMartinezPeck 10/21/2011 14:15'!
buildDBXTalklmage
	DBXTalkImageBuilder new buildImage.! !

!ConfigurationOfMariano class methodsFor: 'building' stamp: 'sdas 10/28/2011 22:48'!
buildFuelImage
	FuelImageBuilder new buildImage.! !

!ConfigurationOfMariano class methodsFor: 'building' stamp: 'MarianoMartinezPeck 10/21/2011 14:16'!
buildMarealmage
	MareaImageBuilder new buildImage.! !

!ConfigurationOfMariano class methodsFor: 'private' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfMariano class methodsFor: 'private' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfMariano class methodsFor: 'metacello tool support' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfMariano class methodsFor: 'loading' stamp: 'MarianoMartinezPeck 10/28/2011 11:23'!
loadCogVM
	CogVMImageBuilder new loadPackages: 'CogVM'! !

!ConfigurationOfMariano class methodsFor: 'loading' stamp: 'MarianoMartinezPeck 10/28/2011 11:23'!
loadDBXTalk
	DBXTalkImageBuilder new loadPackages: 'DBXTalk'.! !

!ConfigurationOfMariano class methodsFor: 'loading' stamp: 'MarianoMartinezPeck 10/28/2011 11:23'!
loadFuel
	FuelImageBuilder new loadPackages: 'Fuel'! !

!ConfigurationOfMariano class methodsFor: 'loading' stamp: 'MarianoMartinezPeck 10/28/2011 11:24'!
loadMarea
	MareaImageBuilder new loadPackages: 'Marea'.! !

!ConfigurationOfMariano class methodsFor: 'loading' stamp: 'MarianoMartinezPeck 10/28/2011 11:24'!
loadTextLint
	GeneralImageBuilder new loadPackages: 'TextLint'.! !

!ConfigurationOfMariano class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
project

	^self new project! !

!ConfigurationOfMariano class methodsFor: 'development support' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfMariano methodsFor: 'baselines' stamp: 'MarianoMartinezPeck 12/25/2011 18:44'!
baseline10: spec 
        <version: '1.0-baseline'>
        
	spec for: #pharo do: [
		
		spec blessing: #baseline.

  " =========================================
The following the list of projects that I DO DEVELOPE. Hence, I always want the bleedingEdge, and most of the times, I want to build an image for them. 
 ========================================="

		spec
			project: 'Fuel' with: [
			spec
				className: 'ConfigurationOfFuel';
				loads: #('DevelopmentGroup' );
				file: 'ConfigurationOfFuel';
				versionString: #bleedingEdge;
				repository: 'http://ss3.gemstone.com/ss/Fuel' ].

		spec
			project: 'Marea' with: [
			spec
				className: 'ConfigurationOfMarea';
				loads: #('default' );
				file: 'ConfigurationOfMarea';
				versionString: #bleedingEdge;
				repository: 'http://www.squeaksource.com/Marea' ].
			
			
		spec
			project: 'DBXTalk' with: [
			spec
				className: 'ConfigurationOfGlorpDBX';
				loads: #('default' );
				file: 'ConfigurationOfGlorpDBX';
				versionString: #bleedingEdge;
				repository: 'http://www.squeaksource.com/DBXTalk' ].
		
		
  " =========================================
The following the list of projects that I usually load and play or develop a little bit. But since they are not my projects, I usually use the latest available metacello version and not the bleedingEdge.. 
 ========================================="
		
		spec
			project: 'CogVM' with: [
			spec
				className: 'ConfigurationOfCog';
				loads: #('default' );
				file: 'ConfigurationOfCog';
				versionString: '3.6';
				"Don't use #bleedingEdge because we need to be in zinc with platform code"
				repository: 'http://www.squeaksource.com/MetacelloRepository' ].
					
		spec
			project: 'TextLint' with: [
			spec
				className: 'ConfigurationOfTextLint';
				loads: #('default' );
				file: 'ConfigurationOfTextLint';
				repository: 'http://www.squeaksource.com/textlint' ].


  " =========================================
The following the list of TOOLS, ADDONS  that I use for my own images. Since they are not my projects, I usually use the latest available metacello version and not the bleedingEdge.
In addition, not all tools and addons are loaded in all type of images I build. Each image decides what to include.
 ========================================="

					
		spec
			project: 'SandcastlesThemes' with: [
			spec
				className: 'ConfigurationOfSandcastleThemes';
				loads: #('default');
				file: 'ConfigurationOfSandcastleThemes';
				repository: 'http://www.squeaksource.com/SandcastlesThemes' ].
		
		spec
			project: 'TilingWindowManager' with: [
			spec
				className: 'ConfigurationOfTilingWindowManager';
				loads: #('default');
				file: 'ConfigurationOfTilingWindowManager';
				versionString: #bleedingEdge;
				repository: 'http://www.squeaksource.com/TilingWindowManager' ].
		
		spec
			project: 'GlamourCore' with: [
			spec
				className: 'ConfigurationOfGlamour';
				loads: #('Core' 'Morphic' );
				file: 'ConfigurationOfGlamour';
				versionString: #bleedingEdge;
				repository: 'http://www.squeaksource.com/Glamour' ].
	
"		spec
			project: 'Glamoroust' with: [
			spec
				className: 'ConfigurationOfGlamoroust';
				loads: #('GT-Inspector' 'GT-Playground' );
				file: 'ConfigurationOfGlamoroust';
				repository: 'http://www.squeaksource.com/glamoroust' ].
		"
		
		spec project: 'Keymapping' with: [
			spec
				className: 'ConfigurationOfKeymapping';
				loads: #('forDeveloper' );
				file: 'ConfigurationOfKeymapping';
				versionString: #bleedingEdge;
				repository: 'http://www.squeaksource.com/ShortWays' ].
		
		
		spec 
			package: 'CodeStats' with: [  spec repository: 'http://www.squeaksource.com/MarianoPhD'];
			package: 'SimpleLogger' with: [  spec repository: 'http://www.squeaksource.com/MarianoPhD'];
			package: 'GT-Inspector' with: [
				spec repository: 'http://www.squeaksource.com/glamoroust';
				requires: #('GlamourCore').
				].
		
  " =========================================
The following is a list of groups for building my own images. Notice that for each image group there should be a class side method #buildXXXImage
 ========================================="
			
	
			
		spec
			group: 'FuelImage' with: #( 'BaseImage' 'SandcastlesThemes' 'Fuel');
			group: 'MareaImage' with: #( 'BaseImage' 'Marea');
			group: 'DBXTalkImage' with: #( 'BaseImage' 'DBXTalk');
			group: 'CogVMImage' with: #( 'BaseImage' 'CogVM');
			
			group: 'BaseImage' with: #("'TilingWindowManager'" 'SimpleLogger' 'CodeStats' 'GT-Inspector' "'Keymapping'").

		 ].
	! !

!ConfigurationOfMariano methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

Object subclass: #GeneralImageBuilder
	instanceVariableNames: ''
	classVariableNames: 'BuildOffline'
	poolDictionaries: ''
	category: 'MarianoBuilder'!

GeneralImageBuilder subclass: #CogVMImageBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarianoBuilder'!

!CogVMImageBuilder methodsFor: 'saving' stamp: 'MarianoMartinezPeck 10/20/2011 20:34'!
baseImageName
	^ 'CogVMGenerator'! !

!CogVMImageBuilder methodsFor: 'preferences' stamp: 'MarianoMartinezPeck 12/20/2011 22:40'!
customPreferences
	PolymorphSystemSettings desktopImageFileName: '/Users/mariano/Pharo/VM/git/cogVMBlessedSSH/blessed/image/cogVMWallpaper.jpg'.
	Debugger logFileName: 'CogVMDebug.log'.
	! !

!CogVMImageBuilder methodsFor: 'saving' stamp: 'MarianoMartinezPeck 10/20/2011 20:34'!
imageDirectory
	"This directory is not by chance. This is the special place where I have the downloaded platform code from git. Hence, I can then easily build the VM"
	^ '/Users/mariano/Pharo/VM/git/cogVMMaster/blessed/image/'! !

!CogVMImageBuilder methodsFor: 'loading' stamp: 'MarianoMartinezPeck 10/28/2011 11:22'!
imageGroupNameToLoad
	^ 'CogVMImage'.	
! !

!CogVMImageBuilder methodsFor: 'building' stamp: 'MarianoMartinezPeck 10/24/2011 17:46'!
lastActions
	super lastActions.
	^ self openHelpWorkspace ! !

!CogVMImageBuilder methodsFor: 'private' stamp: 'mariano 12/7/2011 14:01'!
openHelpWorkspace
	Smalltalk tools workspace openContents: '(ConfigurationOfCog project lastVersion) load

CogMTCocoaIOSConfig new
       generateForDebug;
       generateSources; generate.


"
cd Users/mariano/Pharo/VM/git/cogVMBlessedSSH/blessed/
git pull
/codegen-scripts/extract-commit-info.sh
cd build
rm CMakeCache.txt
cmake .
make clean
make
"'
! !

!CogVMImageBuilder methodsFor: 'repositories' stamp: 'MarianoMartinezPeck 10/27/2011 16:49'!
repositoryName 
	^ 'http://www.squeaksource.com/VMMaker'! !

GeneralImageBuilder subclass: #DBXTalkImageBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarianoBuilder'!

!DBXTalkImageBuilder methodsFor: 'saving' stamp: 'MarianoMartinezPeck 10/17/2011 22:37'!
baseImageName
	^ 'DBXTalk'! !

!DBXTalkImageBuilder methodsFor: 'preferences' stamp: 'MarianoMartinezPeck 10/16/2011 23:17'!
customPreferences
	LogoImageMorph default: (ImageMorph withForm: (ImageReadWriter formFromFileNamed: '/Users/mariano/DBXTalk/logo/DBXTALK 4-6_small.png')).
	PolymorphSystemSettings desktopColor: (Color r: 0.7030000000000001 g: 0.6930000000000001 b: 0.6930000000000001).
	Debugger logFileName: 'DBXTalkDebug.log'.
	
! !

!DBXTalkImageBuilder methodsFor: 'saving' stamp: 'MarianoMartinezPeck 10/17/2011 22:38'!
imageDirectory
	^ '/Users/mariano/DBXTalk/imagenes/'! !

!DBXTalkImageBuilder methodsFor: 'loading' stamp: 'MarianoMartinezPeck 10/28/2011 11:22'!
imageGroupNameToLoad
	^ 'DBXTalkImage'.	
! !

!DBXTalkImageBuilder methodsFor: 'repositories' stamp: 'MarianoMartinezPeck 10/27/2011 16:49'!
repositoryName 
	^ 'http://www.squeaksource.com/DBXTalk'! !

GeneralImageBuilder subclass: #FuelImageBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarianoBuilder'!

!FuelImageBuilder methodsFor: 'saving' stamp: 'MarianoMartinezPeck 10/17/2011 21:10'!
baseImageName
	^ 'Fuel'! !

!FuelImageBuilder methodsFor: 'preferences' stamp: 'MarianoMartinezPeck 12/7/2011 10:32'!
customPreferences
	(Smalltalk at: #FLLogoUtilities) installLogo.
	PolymorphSystemSettings desktopImageFileName: '/Users/mariano/PhD/Marea/Fuel/fotos/1997_Need_For_Speed_2_Special_Edition.jpg'.
	(Smalltalk at: #SandcastlePharoway) beCurrent.
	Debugger logFileName: 'FuelDebug.log'.
	
! !

!FuelImageBuilder methodsFor: 'saving' stamp: 'MarianoMartinezPeck 10/17/2011 21:19'!
imageDirectory
	^ '/Users/mariano/PhD/Marea/Fuel/imagenes/'! !

!FuelImageBuilder methodsFor: 'loading' stamp: 'MarianoMartinezPeck 10/28/2011 11:22'!
imageGroupNameToLoad
	^ 'FuelImage'.	
! !

!FuelImageBuilder methodsFor: 'repositories' stamp: 'MarianoMartinezPeck 10/27/2011 16:49'!
repositoryName 
	^ 'http://www.squeaksource.com/Fuel'! !

!GeneralImageBuilder class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/27/2011 14:36'!
buildOffline
	BuildOffline ifNil: [ BuildOffline := false ].
	^ BuildOffline! !

!GeneralImageBuilder class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/27/2011 14:37'!
buildOffline: aBoolean
	BuildOffline := aBoolean! !

!GeneralImageBuilder methodsFor: 'building' stamp: 'MarianoMartinezPeck 10/30/2011 16:12'!
buildImage
	self loadImagePackages.
	self generalImagePreferences.
	self customPreferences.
	self cleanSystem.
	self lastActions.
	self saveImage.! !

!GeneralImageBuilder methodsFor: 'cleaning' stamp: 'MarianoMartinezPeck 11/1/2011 19:56'!
cleanSystem
	SystemWindow allSubInstancesDo: [:window | window delete].

	"Clear Monticello Caches"
	MCFileBasedRepository flushAllCaches.
	MCMethodDefinition shutDown.
	MCDefinition clearInstances.

	"Cleanup Smalltalk"
	Smalltalk flushClassNameCache.
	Smalltalk organization removeEmptyCategories.
	Smalltalk allClassesAndTraitsDo: [ :each |
		each organization removeEmptyCategories; sortCategories.
		each class organization removeEmptyCategories; sortCategories ].
	
	"Cleanup System Memory"
	Smalltalk garbageCollect.
	Symbol compactSymbolTable.
	
	ScriptLoader new cleanUpForRelease.	

	"put back the author"
	Author fullName: 'MarianoMartinezPeck'.
	! !

!GeneralImageBuilder methodsFor: 'preferences' stamp: 'MarianoMartinezPeck 10/21/2011 11:38'!
customPreferences! !

!GeneralImageBuilder methodsFor: 'preferences' stamp: 'MarianoMartinezPeck 12/25/2011 15:00'!
generalImagePreferences
	UITheme currentSettings fastDragging: true.
	CodeHolder showAnnotationPane: true.
	MCCodeTool showAnnotationPane: true.
	Deprecation raiseWarning: true.
	Debugger alwaysOpenFullDebugger: true.
	Parser warningAllowed: false. 
	TasklistMorph keepOpen: true.
	"(Smalltalk at: #TWMBar) showTWMBar: true."
	Smalltalk tools register: (Smalltalk at: #GTInspector)  as: #objectExplorer.
	" GTPlayground is not yet working correctly, so I disable it for the moment"
	"Smalltalk tools register: (Smalltalk at: #GTPlayground)  as: #workspace."
! !

!GeneralImageBuilder methodsFor: 'building' stamp: 'MarianoMartinezPeck 12/7/2011 10:34'!
generalPreLoad
	MCCacheRepository default directory: self sharedPackageCacheDirectory.
	MCDirectoryRepository defaultDirectoryName: self sharedPackageCacheName.
	Author fullName: 'MarianoMartinezPeck'.
	
! !

!GeneralImageBuilder methodsFor: 'loading' stamp: 'MarianoMartinezPeck 10/28/2011 11:22'!
imageGroupNameToLoad
	^ self subclassResponsibility ! !

!GeneralImageBuilder methodsFor: 'building' stamp: 'MarianoMartinezPeck 10/27/2011 16:46'!
lastActions
	self putMyRepositoriesAtTheEnd.
	self setSqueakSourceUsernameAndPassword.! !

!GeneralImageBuilder methodsFor: 'loading' stamp: 'MarianoMartinezPeck 10/28/2011 11:22'!
loadImagePackages
	self loadPackages: self imageGroupNameToLoad.! !

!GeneralImageBuilder methodsFor: 'loading' stamp: 'MarianoMartinezPeck 10/30/2011 16:11'!
loadPackages: packagesOrGroups
	| version repo |
	self generalPreLoad.
	version := (ConfigurationOfMariano project version: #bleedingEdge).
	self class buildOffline 
		ifTrue: [ 
			repo := MCDirectoryRepository new.
  			repo directory: self sharedPackageCacheDirectory.
 	 		version repositoryOverrides: (OrderedCollection with: repo).
			 ].
	version load: packagesOrGroups.
	 ! !

!GeneralImageBuilder methodsFor: 'private' stamp: 'MarianoMartinezPeck 11/1/2011 20:01'!
putMyRepositoriesAtTheEnd
	| myRepo |
	myRepo :=  MCRepositoryGroup default repositories 
		detect: [:each | each description = self repositoryName]
		ifNone: [ "this means it was loaded offline used the shared package cache, so I do nothing" ^ self ].
	MCRepositoryGroup default  removeRepository: myRepo.
	MCRepositoryGroup default  addRepository: myRepo.
! !

!GeneralImageBuilder methodsFor: 'file directories' stamp: 'MarianoMartinezPeck 10/24/2011 17:52'!
repositoriesPassword
	^ (FileDirectory default oldFileNamed: '/Users/mariano/Pharo/repositoriesPassword.txt') contents
! !

!GeneralImageBuilder methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/27/2011 16:47'!
repositoryName
	^ self subclassResponsibility ! !

!GeneralImageBuilder methodsFor: 'saving' stamp: 'MarianoMartinezPeck 10/17/2011 21:09'!
saveImage

	Smalltalk saveAs: self baseImageName inDirectoryNamed: self imageDirectory
! !

!GeneralImageBuilder methodsFor: 'private' stamp: 'MarianoMartinezPeck 10/24/2011 18:00'!
setSqueakSourceUsernameAndPassword
	"This sets the username and password in all squeaksource repositories. The password must stored in a specific file in the machine where you are building this image."
	(MCRepositoryGroup default  repositories 
		select: [:each | (each isKindOf: MCHttpRepository) 
			and: [each locationWithTrailingSlash includesSubString: 'www.squeaksource.com'] ]) do: [:each |
			each 
				user: 'MMP';
				password: self repositoriesPassword.
			]! !

!GeneralImageBuilder methodsFor: 'file directories' stamp: 'MarianoMartinezPeck 10/21/2011 14:11'!
sharedPackageCacheDirectory.
	^ (FileDirectory on: self sharedPackageCacheName)
		assureExistence;
		yourself! !

!GeneralImageBuilder methodsFor: 'file directories' stamp: 'MarianoMartinezPeck 10/21/2011 14:11'!
sharedPackageCacheName
	^ '/Users/mariano/Pharo/localRepo/'! !

GeneralImageBuilder subclass: #MareaImageBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarianoBuilder'!

!MareaImageBuilder methodsFor: 'saving' stamp: 'MarianoMartinezPeck 10/17/2011 22:37'!
baseImageName
	^ 'Marea'! !

!MareaImageBuilder methodsFor: 'cleaning' stamp: 'MarianoMartinezPeck 10/27/2011 17:02'!
cleanSystem
	SystemWindow allSubInstancesDo: [:window | window delete].
	"Don't do a cleanUpForRelease because I don't know why with Marea everything is screw and I have an error while cleaning the DebuggerMap"
	"ScriptLoader new cleanUpForRelease.	"
	Author fullName: 'MarianoMartinezPeck'.
	! !

!MareaImageBuilder methodsFor: 'preferences' stamp: 'MarianoMartinezPeck 12/13/2011 10:58'!
customPreferences
	LogoImageMorph default: (ImageMorph withForm: (ImageReadWriter formFromFileNamed: '/Users/mariano/PhD/Marea/kitmarea/mareaLogo.png')).
	PolymorphSystemSettings desktopImageFileName: '/Users/mariano/PhD/Marea/kitmarea/mareaBackground.jpg'.
	Debugger logFileName: 'MareaDebug.log'.	
	CodeHolder showAnnotationPane: false.
	MCCodeTool showAnnotationPane: false.
! !

!MareaImageBuilder methodsFor: 'saving' stamp: 'MarianoMartinezPeck 10/17/2011 22:38'!
imageDirectory
	^ '/Users/mariano/PhD/Marea/imagenes/'! !

!MareaImageBuilder methodsFor: 'loading' stamp: 'MarianoMartinezPeck 10/28/2011 11:22'!
imageGroupNameToLoad
	^ 'MareaImage'.	
! !

!MareaImageBuilder methodsFor: 'repositories' stamp: 'MarianoMartinezPeck 10/27/2011 16:49'!
repositoryName 
	^ 'http://www.squeaksource.com/Marea'! !

!SmalltalkImage methodsFor: '*MarianoBuilder' stamp: 'MarianoMartinezPeck 10/28/2011 21:30'!
saveAs: imageName inDirectoryNamed: aDirectoryString

	| newName index |
	
	(FileDirectory default fileExists: (aDirectoryString , imageName, '.' , FileDirectory changeSuffix))
		ifTrue: [
			newName := (FileDirectory on: aDirectoryString ) nextNameFor: imageName extension: FileDirectory imageSuffix.
			"newName := UIManager default
				request: 'Please enter the name for the new image:'
				initialAnswer: newName."
			index := newName findLast: [:c | c = $.].
			newName := newName copyFrom: 1 to: (index - 1).
			
			]
		ifFalse: [ newName := imageName ].
	newName isEmptyOrNil
		ifTrue: [ ^ self ].
	(SourceFiles at: 2) ifNotNil:
		[self closeSourceFiles; "so copying the changes file will always work"
			 saveChangesInFileNamed: (aDirectoryString , newName, '.' , FileDirectory changeSuffix)].
	^self saveImageInFileNamed: (aDirectoryString , newName, '.', FileDirectory imageSuffix)! !
